/*
 * atacando.h
 *
 *  Created on: Jul 5, 2010
 *      Author: mateus
 */

#ifndef ATACANDO_H_
#define ATACANDO_H_

#include "objetos/cubo.h"
#include "objetos/esfera.h"
#include "objetos/paralelepipedo.h"
#include "objetos/wavefront.h"
#include "texture.h"
#include <iostream>

extern GLuint texId;

namespace atacando{
	Objeto *tronco, *cabeca, *pescoco;
	Objeto *coxaEsquerda, *coxaDireita, *canelaDireita, *canelaEsquerda, *peDireito, *peEsquerdo;
	Objeto *articulacaoEsquerda , *articulacaoDireita, *joelhoEsquerdo, *joelhoDireito, *tornozeloDireito, *tornozeloEsquerdo;
	Objeto *bracoEsquerdo, *bracoDireito, *antebracoEsquerdo, *antebracoDireito, *maoEsquerda, *maoDireita;
	Objeto *ombroEsquerdo, *ombroDireito, *cotoveloEsquerdo, *cotoveloDireito, *punhoEsquerdo, *punhoDireito;

	float movimento[3];
	float vetor[3];
	float angulo = 0.0;

	void gerarFrames( Frame primeiro, Frame ultimo, ListaDeFrames* lista, int numeroDeFrames){
		float movimento[3] = { primeiro.movimento[0] , primeiro.movimento[1], primeiro.movimento[2] };
		float vetor[3] = { primeiro.vetorDeRotacao[0] , primeiro.vetorDeRotacao[1], primeiro.vetorDeRotacao[2] };
		float angulo = primeiro.angulo;

		float stepEmX = ( ultimo.movimento[0] - primeiro.movimento[0]) / numeroDeFrames;
		float stepEmY = ( ultimo.movimento[1] - primeiro.movimento[1]) / numeroDeFrames;
		float stepEmZ = ( ultimo.movimento[2] - primeiro.movimento[2]) / numeroDeFrames;
		float stepDoAngulo = ( ultimo.angulo - primeiro.angulo) / numeroDeFrames;

		for(int i = 0; i < numeroDeFrames; i++) {
			lista->push_back(new Frame(movimento, angulo, vetor));
			movimento[0] += stepEmX;
			movimento[1] += stepEmY;
			movimento[2] += stepEmZ;
			angulo += stepDoAngulo;
		}
	}

	void arrumarTronco(){
//		BMPImage texBmp;
//		getBitmapImageData("modelos/textura.bmp", &texBmp);
//		texId = gerarTextura(&texBmp);

		movimento[0] = 0;
		movimento[1] = 0;
		movimento[2] = 0;
		vetor[0] = 1;
		vetor[1] = 0;
		vetor[2] = 0;

		ListaDeFrames lista;
		float movimentoFinal[3];
		movimentoFinal[0] = 0.0;
		movimentoFinal[1] = 3.0;
		movimentoFinal[2] = 0.0;

		movimento[1] = 0.5;
		gerarFrames(Frame(movimentoFinal, 0.0, vetor), Frame(movimento, 0.0, vetor), &lista, 40);

		movimentoFinal[1] = 0.5;
		movimento[1] = -0.5;
		gerarFrames(Frame(movimentoFinal, 0.0, vetor), Frame(movimento, 0.0, vetor), &lista, 10);


		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimentoFinal, 0.0, vetor), &lista, 10);

		movimentoFinal[1] = 3.0;
		movimento[1] = 0.5;
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimentoFinal, 0.0, vetor), &lista, 40);
		tronco = new Wavefront(texId, "modelos/sub_tronco.obj", lista, Cor(GREEN));

		movimento[1] = 0.0;
		lista.clear();
		movimento[0] = 0;
		movimento[1] = 4.5;
		movimento[2] = -0.75;

//		vetor[2] = 1.0;
//		vetor[0] = 0.0;
//		gerarFrames(Frame(movimento, -25.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
//		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, 25.0, vetor), &lista, 25);
//		gerarFrames(Frame(movimento, 25.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
//		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -25.0, vetor), &lista, 25);
//		vetor[2] = 0.0;
//		vetor[0] = 1.0;
		lista.push_back(new Frame(movimento, 0.0, vetor));
		pescoco = new Esfera(0.1, lista, Cor(BLUE));

		movimento[0] = 0.0;
		movimento[1] = 0.8;
		movimento[2] = 0.0;
		lista.clear();
		lista.push_back(new Frame(movimento, 0.0, vetor));
		cabeca = new Wavefront(texId, "modelos/sub_head.obj", lista, Cor(GREEN));

		lista.clear();
		movimento[0] = 0.3;
		movimento[1] = -1.5;
		movimento[2] = 0.0;

		vetor[0] = -5.0;
		vetor[1] = 0.0;
		vetor[2] = 1.0;
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, 40.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, 40.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);

		articulacaoEsquerda = new Esfera(0.1, lista, Cor(BLUE));

		lista.clear();
		movimento[0] = -0.3;
		movimento[1] = -1.5;
		movimento[2] = 0.0;
		vetor[0] = 5.0;
		vetor[1] = 0.0;
		vetor[2] = 1.0;
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -40.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, -40.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);

		articulacaoDireita = new Esfera(0.1, lista, Cor(BLUE));

		vetor[0] = 5.0;
		vetor[1] = 0.0;
		vetor[2] = 1.0;
		lista.clear();
		movimento[0] = 0.5;
		movimento[1] = 3.0;
		movimento[2] = -1.0;

		gerarFrames( Frame(movimento, 0.0 , vetor), Frame(movimento, -95.0, vetor), &lista, 50);
		gerarFrames( Frame(movimento, -95.0 , vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		ombroEsquerdo = new Esfera(0.1, lista, Cor(BLUE));


		lista.clear();
		vetor[0] = 5.0;
		vetor[1] = 0.0;
		vetor[2] = -1.0;
		movimento[0] = -0.5;

		gerarFrames( Frame(movimento, 0.0 , vetor), Frame(movimento, -95.0, vetor), &lista, 50);
		gerarFrames( Frame(movimento, -95.0 , vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		ombroDireito = new Esfera(0.1, lista, Cor(BLUE));
		movimento[2] = 0.0;

		vetor[0] = 1.0;
		vetor[1] = 0.0;
		vetor[2] = 0.0;
	}

	void arrumarBracosECotovelos(){
		ListaDeFrames lista;

		movimento[0] = -2.0;
		movimento[1] = -1.5;
		movimento[2] = 0.0;
		lista.push_back(new Frame(movimento, 0.0, vetor));
		bracoDireito = new Wavefront(texId, "modelos/sub_braco_direito.obj", lista, Cor(GREEN));

		movimento[0] = 2.0;
		movimento[1] = -1.5;
		movimento[2] = 0.0;
		lista.clear();
		lista.push_back(new Frame(movimento, 0.0, vetor));
		bracoEsquerdo = new Wavefront(texId, "modelos/sub_braco_esquerdo.obj", lista, Cor(GREEN));

		movimento[0] = -0.5;
		movimento[1] = -2.0;
		movimento[2] = 0.0;
		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -50.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, -50.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -50.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, -50.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
		cotoveloDireito = new Esfera(0.1, lista, Cor(BLUE));

		lista.clear();
		movimento[0] = 0.5;
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -50.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, -50.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -50.0, vetor), &lista, 25);
		gerarFrames(Frame(movimento, -50.0, vetor), Frame(movimento, 0.0, vetor), &lista, 25);
		cotoveloEsquerdo = new Esfera(0.1, lista, Cor(BLUE));
	}

	void arrumarAntebracosEPunhos(){
		ListaDeFrames lista;

		movimento[0] = 0.0;
		movimento[1] = -1.5;
		movimento[2] = 0.0;

		lista.push_back(new Frame(movimento, 0.0, vetor));
		antebracoDireito = new Wavefront(texId, "modelos/sub_antebraco_direito.obj", lista, Cor(GREEN));
		antebracoEsquerdo = new Wavefront(texId, "modelos/sub_antebraco_esquerdo.obj", lista, Cor(GREEN));

		movimento[1] = -1.5;
		vetor[2] = 1.0;
		vetor[0] = 0.0;
		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -90.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, -90.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		punhoDireito = new Esfera(0.1, lista, Cor(BLUE));

		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, 90.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, 90.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		punhoEsquerdo = new Esfera(0.1, lista, Cor(BLUE));

		movimento[1] = -0.5;
		lista.clear();

		lista.push_back(new Frame(movimento, 0.0, vetor));
		maoDireita = new Wavefront(texId, "modelos/sub_mao_direita.obj", lista, Cor(GREEN));
		maoEsquerda = new Wavefront(texId, "modelos/sub_mao_esquerda.obj", lista, Cor(GREEN));

		vetor[0] = 1.0;
		vetor[2] = 0.0;

	}

	void arrumarCoxasEJoelhos(){
		ListaDeFrames lista;
		movimento[0] = 0.3*3;
		movimento[1] = -0.73*3.0;
		movimento[2] = 0.0;
		angulo = 0.0;
		Frame* frameCoxaEsquerda = new Frame( movimento, angulo, vetor);
		movimento[0] = -0.3*3;
		movimento[1] = -0.73*3.0;
		movimento[2] = 0.0;
		Frame* frameCoxaDireita = new Frame( movimento, angulo, vetor);

		lista.push_back(frameCoxaEsquerda);
		coxaEsquerda = new Wavefront(texId, "modelos/sub_coxa_esquerda.obj", lista, Cor(GREEN));
		lista.clear();
		lista.push_back(frameCoxaDireita);
		coxaDireita = new Wavefront(texId, "modelos/sub_coxa_direita.obj", lista, Cor(GREEN));

		lista.clear();
		movimento[0] = 0.5;
		movimento[1] = -3.0;
		movimento[2] = 0.25;
		angulo = 0.0;

		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, 90.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, 90.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		joelhoEsquerdo = new Wavefront(texId, "modelos/sub_joelho_esquerdo.obj", lista, Cor(GREEN));

		movimento[0] = -0.5;
		movimento[1] = -3.0;
		movimento[2] = 0.25;
		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, 90.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, 90.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		joelhoDireito = new Wavefront(texId, "modelos/sub_joelho_direito.obj", lista, Cor(GREEN));

	}

	void arrumarCanelaETornozelo(){
		ListaDeFrames lista;
		movimento[0] = 0.0;
		movimento[1] = -2.0;
		movimento[2] = -1.0;
		angulo = 0.0;
		lista.push_back(new Frame( movimento, angulo, vetor) );
		canelaDireita = new Wavefront(texId, "modelos/sub_canela_direita.obj", lista, Cor(GREEN));
		canelaEsquerda = new Wavefront(texId, "modelos/sub_canela_esquerda.obj", lista, Cor(GREEN));

		lista.clear();
		movimento[0] = 0.0;
		movimento[1] = 0.0;
		movimento[2] = 0.0;
		lista.push_back(new Frame( movimento, angulo, vetor) );
		peDireito = new Wavefront(texId, "modelos/sub_pe_direito.obj", lista, Cor(GREEN));

		lista.clear();
		movimento[0] = 0.0;
		movimento[1] = 0.0;
		movimento[2] = 0.0;
		lista.push_back(new Frame( movimento, angulo, vetor) );

		peEsquerdo = new Wavefront(texId, "modelos/sub_pe_esquerdo.obj", lista, Cor(GREEN));

		movimento[0] = 0.0;
		movimento[1] = -3.0;
		movimento[2] = 1.0;
		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -45.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, -45.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);

		tornozeloDireito = new Esfera(0.1, lista, Cor(BLUE));

		movimento[0] = 0.25;
		movimento[1] = -3.0;
		movimento[2] = 1.0;
		lista.clear();
		gerarFrames(Frame(movimento, 0.0, vetor), Frame(movimento, -45.0, vetor), &lista, 50);
		gerarFrames(Frame(movimento, -45.0, vetor), Frame(movimento, 0.0, vetor), &lista, 50);
		tornozeloEsquerdo = new Esfera(0.1, lista, Cor(BLUE));
	}

	void arrumarHierarquia() {

		*tronco << pescoco;
		*pescoco << cabeca;

		*tronco << articulacaoDireita;
		*tronco << articulacaoEsquerda;
		*articulacaoDireita << coxaDireita;
		*articulacaoEsquerda << coxaEsquerda;
		*coxaDireita << joelhoDireito;
		*coxaEsquerda << joelhoEsquerdo;
		*joelhoEsquerdo << canelaEsquerda;
		*joelhoDireito << canelaDireita;
		*canelaDireita << tornozeloDireito;
		*canelaEsquerda << tornozeloEsquerdo;
		*tornozeloDireito << peDireito;
		*tornozeloEsquerdo << peEsquerdo;

		*tronco << ombroDireito;
		*tronco << ombroEsquerdo;
		*ombroDireito << bracoDireito;
		*ombroEsquerdo << bracoEsquerdo;
		*bracoDireito << cotoveloDireito;
		*bracoEsquerdo << cotoveloEsquerdo;
		*cotoveloDireito << antebracoDireito;
		*cotoveloEsquerdo << antebracoEsquerdo;
		*antebracoDireito << punhoDireito;
		*antebracoEsquerdo << punhoEsquerdo;
		*punhoDireito << maoDireita;
		*punhoEsquerdo << maoEsquerda;
	}

}

#endif /* ATACANDO_H_ */
