/*
 * main.cc
 *
 *  Created on: Jun 26, 2010
 *      Author: mateus
 */
#include "correndo.h"
#include "atacando.h"
#include <GL/glut.h>
#include <GL/glu.h>
#include <unistd.h>

float anguloEmY, anguloEmX;
float zoom = -45.0f;
bool seCorrendo;

GLfloat			diffuseLight[] = { 0.5f, 0.5f, 0.5f, 1.0};
GLfloat			ambientLight[] = { 0.4f, 0.4f, 0.4f, 1.0};
GLfloat			emissiveLight[] = { 0.0f, 0.0f, 0.0f, 1.0};
GLfloat			lightPos[] = { 0.0f, 300.0f, -200.0f, 1.0f };


int InitGL(void) {
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	return true;
}

void redesenhaMundo(void){
	glPushMatrix();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glLoadIdentity();



	glTranslatef(0.0, 0.0,zoom);

	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_AMBIENT, diffuseLight);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
//	glLightfv(GL_LIGHT0, GL_EMISSION, emissiveLight);
	glEnable(GL_LIGHT0);


	glRotatef(anguloEmY, 0.0, 1.0, 0.0);
	glRotatef(anguloEmX, 1.0, 0.0, 0.0);

	glBegin(GL_QUADS);
				glVertex3f( -30.0, -10.0, -30.0 );
				glVertex3f( 30.0 , -10.0, -30.0 );
				glVertex3f( 30.0 , -10.0, 30.0 );
				glVertex3f( -30.0, -10.0, 30.0 );
	glEnd();

	if(seCorrendo)
		correndo::tronco->desenhar();
	else
		atacando::tronco->desenhar();

	glPopMatrix();
    glutSwapBuffers();
}

void idle(void) {
	//NADA AINDA
}

void mostraMundo(int){
    glutTimerFunc(1000.0/60.0, mostraMundo, 0);
    redesenhaMundo();
}

void redimensionaJanela(int width, int height)  {}

void tecla(unsigned char tecla, int x, int y)   {
	switch( tecla ){
	case 27: //ASCII pra ESC, etc.
		exit(0);
	}
}
void teclas_de_seta ( int tecla, int x, int y ) {
	switch(tecla){
	case GLUT_KEY_LEFT:
		anguloEmY += 5.0f;
		break;
	case GLUT_KEY_RIGHT:
		anguloEmY -= 5.0f;
		break;
	case GLUT_KEY_UP:
		anguloEmX += 5.0f;
		break;
	case GLUT_KEY_DOWN:
		anguloEmX -= 5.0f;
		break;
	case GLUT_KEY_F1:
		seCorrendo = !seCorrendo;
		break;
	case GLUT_KEY_F2:
		zoom += 3.0;
		break;
	case GLUT_KEY_F3:
		zoom -= 3.0;
	}
}

int main(int  argc,    char *argv[]) {
	ListaDeFrames lista;
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(640, 480);
    glutInitWindowPosition(0, 0);
    glutCreateWindow("Modelos Hierárquicos");

    glutReshapeFunc(redimensionaJanela);
    glutDisplayFunc(redesenhaMundo);
    glutKeyboardFunc(tecla);
    glutSpecialFunc(teclas_de_seta);
    glutIdleFunc(idle);
    glutTimerFunc(1000.0/60.0, mostraMundo, 0);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(45.0f,(GLfloat)640/(GLfloat)480,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_COLOR_MATERIAL);
	glLoadIdentity();

    InitGL();

    {
    using namespace correndo;
    arrumarTronco();
	arrumarCoxasEJoelhos();
	arrumarBracosECotovelos();
	arrumarAntebracosEPunhos();
	arrumarCanelaETornozelo();
	arrumarHierarquia();
    }
    {
	using namespace atacando;
	arrumarTronco();
	arrumarCoxasEJoelhos();
	arrumarBracosECotovelos();
	arrumarAntebracosEPunhos();
	arrumarCanelaETornozelo();
	arrumarHierarquia();
    }

    glEnable(GL_TEXTURE_2D);
    glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE );

    glutMainLoop();
    return (0);
}


