/*
 * objeto.cc
 *
 *  Created on: Jun 22, 2010
 *      Author: mateus
 */
#include "objeto.h"
#include <GL/gl.h>

Objeto::Objeto( ListaDeFrames frames, Cor cor) : cor(cor), frames(frames){
	this->atual = this->frames.begin();
}

Objeto::~Objeto(){
}

void Objeto::desenhar(){
	glPushMatrix();
	atual++;
	atual =  (atual == frames.end()) ? frames.begin() : atual;
	this->ajustar();
	this->_desenhar();
	for(set<Objeto*>::iterator cadaFilho = this->filhos.begin(); cadaFilho != this->filhos.end(); cadaFilho++) {
		(*cadaFilho)->desenhar();
	}
	glPopMatrix();
}

Objeto* Objeto::operator <<( Objeto* novoFilho){
	this->filhos.insert(novoFilho);
	return this;
}

void Objeto::ajustar(){
	Frame* meuFrame = *atual;
	float* translacao = meuFrame->movimento;
	float* vetor = meuFrame->vetorDeRotacao;
	glTranslatef(translacao[0], translacao[1], translacao[2]);
	glRotatef(meuFrame->angulo, vetor[0], vetor[1], vetor[2]);
	glColor4f(cor.red, cor.green, cor.blue, cor.alpha);
}


