/*
 * wavefront.h
 *
 *  Created on: Jul 4, 2010
 *      Author: puel
 */

#ifndef WAVEFRONT_H_
#define WAVEFRONT_H_

#include "objeto.h"
#include <string>
#include <vector>
#include <GL/gl.h>

struct coordenada {
	double x, y, z;
};

struct uv {
	double x, y;
};

struct triangulo {
	unsigned int v1, v2, v3;
	unsigned int n1, n2, n3;
	unsigned int t1, t2, t3;
};

class Wavefront : public Objeto {
public:
	Wavefront(GLuint textura, std::string arquivo, ListaDeFrames frames, Cor cor = Cor());
	virtual ~Wavefront();
protected:
	void _desenhar();
private:
	std::vector<coordenada> vertices;
	std::vector<coordenada> normais;
	std::vector<triangulo> faces;
	std::vector<uv> texturas;
	GLuint textura;
};

#endif /* WAVEFRONT_H_ */
